Debian Bug report logs - #637360
[arm] backtrace() requires unwind information

version graph

Package: libc6; Maintainer for libc6 is GNU Libc Maintainers <debian-glibc@lists.debian.org>; Source for libc6 is src:eglibc.

Reported by: Stéphane Glondu <glondu@debian.org>

Date: Wed, 10 Aug 2011 16:18:10 UTC

Severity: normal

Found in version eglibc/2.13-15

Done: Aurelien Jarno <aurelien@aurel32.net>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, debian-ocaml-maint@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>:
Bug#637360; Package libc6. (Wed, 10 Aug 2011 16:18:13 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stéphane Glondu <glondu@debian.org>:
New Bug report received and forwarded. Copy sent to debian-ocaml-maint@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>. (Wed, 10 Aug 2011 16:18:13 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Stéphane Glondu <glondu@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: backtrace() doesn't work on armel
Date: Wed, 10 Aug 2011 18:17:35 +0200
Package: libc6
Version: 2.13-15
Severity: normal

Hello,

The test suite of ocaml-extunix 0.0.3-1 fails on armel because the
following program:

  #include <execinfo.h>

  int main() {
    void *buffer[100];
    return backtrace(buffer, 100);
  }

returns 0. It returns with a non-zero status (3 everywhere I've tried
myself) on all other release architectures.

Is that expected?


Cheers,

-- 
Stéphane

-- System Information:
Debian Release: wheezy/sid
  APT prefers testing
  APT policy: (990, 'testing'), (500, 'unstable'), (1, 'experimental')
Architecture: amd64 (x86_64)

Kernel: Linux 3.0.0-1-amd64 (SMP w/2 CPU cores)
Locale: LANG=fr_FR.utf8, LC_CTYPE=fr_FR.utf8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages libc6 depends on:
ii  libc-bin                      2.13-15    Embedded GNU C Library: Binaries
ii  libgcc1                       1:4.6.1-6  GCC support library

libc6 recommends no packages.

Versions of packages libc6 suggests:
ii  debconf [debconf-2.0]         1.5.41     Debian configuration management sy
pn  glibc-doc                     <none>     (no description available)
ii  locales                       2.13-15    Embedded GNU C Library: National L

-- debconf information excluded




Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>:
Bug#637360; Package libc6. (Wed, 10 Aug 2011 23:21:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>. (Wed, 10 Aug 2011 23:21:03 GMT) Full text and rfc822 format available.

Message #10 received at 637360@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: Stéphane Glondu <glondu@debian.org>
Cc: 637360@bugs.debian.org
Subject: Re: backtrace() doesn't work on armel
Date: Wed, 10 Aug 2011 18:15:59 -0500
severity 637360 wishlist
retitle 637360 [arm] backtrace() requires unwind information
# unlikely to be fixed any time soon
tags 637360 + upstream wontfix
quit

Hi Stéphane,

Stéphane Glondu wrote:

>   #include <execinfo.h>
>
>   int main() {
>     void *buffer[100];
>     return backtrace(buffer, 100);
>   }
>
> returns 0. It returns with a non-zero status (3 everywhere I've tried
> myself) on all other release architectures.
>
> Is that expected?

I'm surprised it works on mips.  Building with -funwind-tables should
help.

This is a somewhat fundamental limitation, and very hard to work
around.  See e.g. [1] for inspiration if you want to work on it.

Hope that helps,
Jonathan

[1] http://www.celinux.org/elc08_presentations/ELC2008%20-%20Back-tracing%20in%20MIPS-based%20Linux%20Systems.pdf




Severity set to 'wishlist' from 'normal' Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Wed, 10 Aug 2011 23:21:04 GMT) Full text and rfc822 format available.

Changed Bug title to '[arm] backtrace() requires unwind information' from 'backtrace() doesn't work on armel' Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Wed, 10 Aug 2011 23:21:05 GMT) Full text and rfc822 format available.

Added tag(s) upstream and wontfix. Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Wed, 10 Aug 2011 23:21:06 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>:
Bug#637360; Package libc6. (Thu, 11 Aug 2011 07:03:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Aurelien Jarno <aurelien@aurel32.net>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>. (Thu, 11 Aug 2011 07:03:03 GMT) Full text and rfc822 format available.

Message #21 received at 637360@bugs.debian.org (full text, mbox):

From: Aurelien Jarno <aurelien@aurel32.net>
To: Jonathan Nieder <jrnieder@gmail.com>, 637360@bugs.debian.org
Cc: Stéphane Glondu <glondu@debian.org>
Subject: Re: Bug#637360: backtrace() doesn't work on armel
Date: Thu, 11 Aug 2011 09:00:54 +0200
# Restoring original tags and severity
severity 637360 normal
tag 637360 - upstream 
tag 637360 - wontfix
thanks

On Wed, Aug 10, 2011 at 06:15:59PM -0500, Jonathan Nieder wrote:
> severity 637360 wishlist
> retitle 637360 [arm] backtrace() requires unwind information
> # unlikely to be fixed any time soon
> tags 637360 + upstream wontfix
> quit
> 
> Hi Stéphane,
> 
> Stéphane Glondu wrote:
> 
> >   #include <execinfo.h>
> >
> >   int main() {
> >     void *buffer[100];
> >     return backtrace(buffer, 100);
> >   }
> >
> > returns 0. It returns with a non-zero status (3 everywhere I've tried
> > myself) on all other release architectures.
> >
> > Is that expected?
> 
> I'm surprised it works on mips.  Building with -funwind-tables should
> help.
> 

Backtrace code for ARM EABI has been added in glibc 2.11 [1], and is 
based on unwind information. -funwind-tables is therefore necessary to 
get it working, and then backtrace() is fully functional.

I therefore don't see the need to tag this bug as wontfix. In my opinion
in can even be closed.

[1] http://sourceware.org/ml/libc-ports/2009-06/msg00012.html

-- 
Aurelien Jarno	                        GPG: 1024D/F1BCDB73
aurelien@aurel32.net                 http://www.aurel32.net




Severity set to 'normal' from 'wishlist' Request was from Aurelien Jarno <aurelien@aurel32.net> to control@bugs.debian.org. (Thu, 11 Aug 2011 07:03:07 GMT) Full text and rfc822 format available.

Removed tag(s) upstream. Request was from Aurelien Jarno <aurelien@aurel32.net> to control@bugs.debian.org. (Thu, 11 Aug 2011 07:03:07 GMT) Full text and rfc822 format available.

Removed tag(s) wontfix. Request was from Aurelien Jarno <aurelien@aurel32.net> to control@bugs.debian.org. (Thu, 11 Aug 2011 07:03:08 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, GNU Libc Maintainers <debian-glibc@lists.debian.org>:
Bug#637360; Package libc6. (Thu, 11 Aug 2011 18:48:11 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonathan Nieder <jrnieder@gmail.com>:
Extra info received and forwarded to list. Copy sent to GNU Libc Maintainers <debian-glibc@lists.debian.org>. (Thu, 11 Aug 2011 18:48:11 GMT) Full text and rfc822 format available.

Message #32 received at 637360@bugs.debian.org (full text, mbox):

From: Jonathan Nieder <jrnieder@gmail.com>
To: Stéphane Glondu <glondu@debian.org>
Cc: 637360@bugs.debian.org
Subject: Re: backtrace() doesn't work on armel
Date: Thu, 11 Aug 2011 13:47:01 -0500
Aurelien Jarno wrote:

> Backtrace code for ARM EABI has been added in glibc 2.11 [1], and is 
> based on unwind information. -funwind-tables is therefore necessary to 
> get it working, and then backtrace() is fully functional.
>
> I therefore don't see the need to tag this bug as wontfix.

Sure, I probably assumed too much.  Stéphane, does -funwind-tables
take care of your needs?

Thanks, both.




Reply sent to Aurelien Jarno <aurelien@aurel32.net>:
You have taken responsibility. (Fri, 02 Sep 2011 20:24:03 GMT) Full text and rfc822 format available.

Notification sent to Stéphane Glondu <glondu@debian.org>:
Bug acknowledged by developer. (Fri, 02 Sep 2011 20:24:03 GMT) Full text and rfc822 format available.

Message #37 received at 637360-done@bugs.debian.org (full text, mbox):

From: Aurelien Jarno <aurelien@aurel32.net>
To: Stéphane Glondu <glondu@debian.org>, 637360-done@bugs.debian.org
Subject: Re: Bug#637360: backtrace() doesn't work on armel
Date: Fri, 2 Sep 2011 22:20:37 +0200
On Thu, Aug 11, 2011 at 01:47:01PM -0500, Jonathan Nieder wrote:
> Aurelien Jarno wrote:
> 
> > Backtrace code for ARM EABI has been added in glibc 2.11 [1], and is 
> > based on unwind information. -funwind-tables is therefore necessary to 
> > get it working, and then backtrace() is fully functional.
> >
> > I therefore don't see the need to tag this bug as wontfix.
> 
> Sure, I probably assumed too much.  Stéphane, does -funwind-tables
> take care of your needs?
> 

Given backtrace() works correctly when compiled with -funwind-tables, I
guess this bug can be closed. I am doing that with this mail, feel free
to reopen it if you disagree.

-- 
Aurelien Jarno	                        GPG: 1024D/F1BCDB73
aurelien@aurel32.net                 http://www.aurel32.net




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sat, 01 Oct 2011 07:38:01 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 00:38:29 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.